-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassEventSet.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassEventSet where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Constructor for EventSet
new :: IO (HG3DClass)
 -- ^ 
new =
  alloca $ \a1' -> 
  new'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 47 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Destructor for EventSet
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 51 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Add a new EventEventSet
addEvent :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object containing the name to give the new Event. The name must be unique for the EventSet.
  ->  IO ()
 -- ^ return value - Nothing    
addEvent a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  addEvent'_ a1' a2' >>= \res ->
  return ()
{-# LINE 56 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Removes the Event
removeEvent :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object containing the name of the Event to remove. If no such Event exists, nothing happens.
  ->  IO ()
 -- ^ return value - Nothing.     
removeEvent a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  removeEvent'_ a1' a2' >>= \res ->
  return ()
{-# LINE 61 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Remove all EventEventSet
removeAllEvents :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing     
removeAllEvents a1 =
  withHG3DClass a1 $ \a1' -> 
  removeAllEvents'_ a1' >>= \res ->
  return ()
{-# LINE 65 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Checks to see if an EventEventSet
isEventPresent :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name
  ->  IO (Bool)
 -- ^ return value - true if an     
isEventPresent a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  isEventPresent'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 71 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Fires the named event passing the given EventArgs
fireEvent :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Event that is to be fired (triggered)
  ->  HG3DClass  -- ^ args - The EventArgs (or derived) object that is to be bassed to each subscriber of the Event. Once all subscribers have been called the 'handled' field of the event is updated appropriately.
  ->  String  -- ^ eventNamespace - String object describing the global event namespace prefix for this event.
  ->  IO ()
 -- ^ return value - Nothing.     
fireEvent a1 a2 a3 a4 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withHG3DClass a3 $ \a3' -> 
  withCString a4 $ \a4' -> 
  fireEvent'_ a1' a2' a3' a4' >>= \res ->
  return ()
{-# LINE 78 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Return whether the EventSet
isMuted :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ 
isMuted a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isMuted'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 83 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}

-- | Set the mute state for this EventSet
setMutedState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - 
--
--
  ->  IO ()
 -- ^ return value - Nothing.     
setMutedState a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setMutedState'_ a1' a2' >>= \res ->
  return ()
{-# LINE 88 ".\\HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_construct"
  new'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_addEvent"
  addEvent'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_removeEvent"
  removeEvent'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_removeAllEvents"
  removeAllEvents'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_isEventPresent"
  isEventPresent'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_fireEvent"
  fireEvent'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_isMuted"
  isMuted'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassEventSet.chs.h cegui_evtst_setMutedState"
  setMutedState'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))
